#include "trainserver.h"

using namespace std;
using namespace salt;

FUNCTION(TrainServer, init)
{
    string trainSysName;
    if (
        (in.GetSize() != 1) ||
        (! in.GetValue(in.begin(), trainSysName))
       )
    {
        return false;
    }
    
    obj->Init(trainSysName);
    return true;
}

FUNCTION(TrainServer, setActiveId)
{
    string id;
    if (
        (in.GetSize() != 1) ||
        (! in.GetValue(in.begin(), id))
       )
    {
        return false;
    }
    
    obj->SetActiveId(id);
    return true;
}

FUNCTION(TrainServer, getActiveId)
{
    return obj->GetActiveId();
}

FUNCTION(TrainServer, moveAndRotateAgent)
{
    Vector3f pos;
    float angle;
    if (
         (in.GetSize() != 4) ||
         (! in.GetValue(in[0], pos[0])) ||
         (! in.GetValue(in[1], pos[1])) ||
         (! in.GetValue(in[2], pos[2])) ||
         (! in.GetValue(in[3], angle))
       )
    {
        return false;
    }
    obj->MoveAndRotateAgent(pos, angle);
    return true;
}

FUNCTION(TrainServer, dropBall)
{
    Vector3f pos;
    if (
         (in.GetSize() != 3) ||
         (! in.GetValue(in[0], pos[0])) ||
         (! in.GetValue(in[1], pos[1])) ||
         (! in.GetValue(in[2], pos[2]))
       )
    {
        return false;
    }
    obj->DropBall(pos);
    return true;
}

FUNCTION(TrainServer, setBallVel)
{
    Vector3f vel(0,0,0);
    if (
         (in.GetSize() != 3) ||
         (! in.GetValue(in[0], vel[0])) ||
         (! in.GetValue(in[1], vel[1])) ||
         (! in.GetValue(in[2], vel[2]))
       )
    {
        return false;
    }
    obj->SetBallVel(vel);
    return true;
}

FUNCTION(TrainServer, getBallPos)
{
    int index = 0;
    if (
         (in.GetSize() != 1) ||
         (! in.GetValue(in[0], index))
       )
    {
        return false;
    }
    return  obj->GetBallPos()[index];

}

FUNCTION(TrainServer, saveRobotScene)
{
    return obj->SaveRobotScene();
}

FUNCTION(TrainServer, restoreRobotScene)
{
    return obj->RestoreRobotScene();
}

void CLASS(TrainServer)::DefineClass()
{
    DEFINE_BASECLASS(zeitgeist/Node);
    DEFINE_FUNCTION(init);
    DEFINE_FUNCTION(setActiveId);
    DEFINE_FUNCTION(getActiveId);
    DEFINE_FUNCTION(moveAndRotateAgent);
    DEFINE_FUNCTION(dropBall);
    DEFINE_FUNCTION(setBallVel);
    DEFINE_FUNCTION(saveRobotScene);
    DEFINE_FUNCTION(restoreRobotScene);
    DEFINE_FUNCTION(getBallPos);
}

